package com.xkrs.common;

import com.xkrs.fireseason.FireSeasonConfigService;
import com.xkrs.utilsnew.DateTimeUtils;
import com.xkrs.utilsnew.WeiXinMessageUtils;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

import javax.annotation.Resource;
import java.time.LocalDateTime;

/**
 * 定时任务
 */
@Configuration
@EnableScheduling
public class StaticScheduleTask {

    @Resource
    private FireSeasonConfigService fireSeasonConfigService;

    //每小时更新一次订阅
    @Scheduled(cron = "0 0 * * * ?")
    private void syncSubscribe() {
        fireSeasonConfigService.updateFireSeasonConfig();
    }

    //每天中午12点测试一次微信消息推送
    @Scheduled(cron = "0 0 */12 * * ?")
    private void testPushWeiXinMessage() {
        try {
            WeiXinMessageUtils.sendMsg("18447024917@chatroom", "微信发消息测试 " + DateTimeUtils.localDateTimeToString(LocalDateTime.now()), 0);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}