package com.xkrs.utilsnew;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.xkrs.model.vo.TianDiTuGeocodeVo;
import com.xkrs.utilsold.HttpClientUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;

public class TianDiTuApiUtil {

    private static final Logger log = LoggerFactory.getLogger(TianDiTuApiUtil.class);

    public static TianDiTuGeocodeVo geocode(double longitude, double latitude) {

        try {

            Map<String, Object> jsonObject = new HashMap<>();
            jsonObject.put("lon", longitude);
            jsonObject.put("lat", latitude);
            jsonObject.put("ver", 1);
            String jsonParams = new JSONObject(jsonObject).toString();
            String encodedParams = URLEncoder.encode(jsonParams, "UTF-8");
            String url = "http://api.tianditu.gov.cn/geocoder?postStr=" + encodedParams + "&type=geocode&tk=e16fa4bdf9a5f59195239ea28622e3d5";
            return JSON.parseObject(HttpClientUtils.sendHttpGet(url), TianDiTuGeocodeVo.class);

        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;

    }

    public static void main(String[] args) {
        TianDiTuGeocodeVo geocode = geocode(110.89, 36.78);
    }

}
